<?php
/**
* Field Plug for AdsManager
* Author: Thomas PAPIN
* URL:  http://www.joomprod.com
* mail: webmaster@joomprod.com
**/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_SITE.DS."components".DS."com_adsmanager".DS."lib".DS."core.php");

// no direct access
defined('_JEXEC') or die('Restricted access');

class AdsManagerYouTubePlugin {

	var $_db;
	
	function getListDisplay($content,$field)
	{
		return AdsManagerYouTubePlugin::getDetailsDisplay($content,$field);
	}

	function getDetailsDisplay($content,$field)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$value = @$content->$fieldname;
		
		$return ="";
		
		if ($value != "")
		{
			preg_match( "/.+v=(.+)$/", $value, $regs );
			$key = $regs[1];
			$this->_db->setQuery("SELECT * FROM #__adsmanager_youtube_conf WHERE fieldid = $field->fieldid");
			$conf =$this->_db->loadObject();
			$return .= '<object width="'.$conf->width.'" height="'.$conf->height.'">';
			$return .=	'<param name="movie" value="http://www.youtube.com/v/'.$key.'&hl=fr&fs=1"></param>';
			$return .=	'<param name="allowFullScreen" value="true"></param>';
			$return .=	'<param name="allowscriptaccess" value="always"></param>';
			$return .=	'<embed src="http://www.youtube.com/v/'.$key.'&hl=fr&fs=1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$conf->width.'" height="'.$conf->height.'">';
			$return .=	'</embed>';
			$return .=	'</object>';
			$return .=	'<br/>';
		}
		return $return;
	}

	function getFormDisplay($content,$field,$default=null)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$value = @$content->$fieldname;
		
       	$return = '<div id="'.$field->name.'"><input type="text" size="30" mosReq="'.$field->required.'" mosLabel="'.htmlspecialchars($field->title).'" name="youtube_key'.$fieldid.'" value="'.$value.'" /></div>';
		$return .= '&nbsp;Enter Youtube URL';
		return $return;
	}

	function onFormSave(&$content,$field)
	{
		$url = JRequest::getVar("youtube_key".$field->fieldid,0);
		return $url;
	}
	
	function onDelete($directory,$contentid = -1)
	{
		if ($contentid == -1)
			$query = "DELETE FROM #__adsmanager_youtube ".
					"WHERE 1";
		else
			$query = "DELETE FROM #__adsmanager_youtube ".
					"WHERE contentid = $contentid";
		$this->_db->setQuery($query);
		$this->_db->query();
	}
	
	function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divYouTubeOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		$return .= "elem=getObject('youtube_width');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('youtube_height');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}
	
	function getEditFieldJavaScriptActive()
	{
        $return = "disableAll();";
		$return .= "elem=getObject('divYouTubeOptions');";
        $return .= "elem.style.visibility = 'visible';";
        $return .= "elem.style.display = 'block';";
		$return .= "elem=getObject('youtube_width');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('youtube_height');";
		$return .= "elem.setAttribute('mosReq',1);";
		return $return;
	}

	function getEditFieldOptions($fieldid)
	{
		$this->install();
		$this->_db->setQuery("SELECT * FROM #__adsmanager_youtube_conf WHERE fieldid = '$fieldid'");
		$row = $this->_db->loadObject();
		
		$return = "<div id='divYouTubeOptions'>";
		$return .= "<table class='adminform'>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Player Width</td>";
		$return .= "<td width='20%' align=left><input type='text' id='youtube_width' name='youtube_width' mosReq=1 mosLabel='Player Width' class='inputbox' value='".@$row->width."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Player Height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='youtube_height' name='youtube_height' mosReq=1 mosLabel='Player Height' class='inputbox' value='".@$row->height."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "</table>";
		$return .= "</div>";
		return $return;
	}

	function saveFieldOptions($field)
	{
		$this->install();
		$width =  JRequest::getInt("youtube_width",0);
		$height = JRequest::getInt("youtube_height",0);
		$this->_db->setQuery("DELETE FROM #__adsmanager_youtube_conf WHERE fieldid = ".(int)$field->fieldid);
		$this->_db->query();
		$this->_db->setQuery("INSERT INTO #__adsmanager_youtube_conf VALUES ($field->fieldid,$width,$height)");
		$this->_db->query();
		return;
	}
	
	function getFieldName()
	{
		return "YouTube Player";
	}
	
	function install()
	{		
		$query = "CREATE TABLE IF NOT EXISTS `#__adsmanager_youtube_conf` ( ".
			  "`fieldid` int(10) unsigned default NULL, ".
			  "`width` int(10) unsigned default '500', ".
			  "`height` int(10) unsigned default '300', ".
			  "PRIMARY KEY  (`fieldid`) ".
			  "); ";
		$this->_db->setQuery($query);
		$this->_db->query();
	}
	
	function uninstall()
	{
		$query = "DROP TABLE `#__adsmanager_youtube_conf`";
		$this->_db->setQuery($query);
		$this->_db->query();
	}
	
	function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}

$plugins["youtube"] = new AdsManagerYouTubePlugin();
?>